;/* -----------------------------------------------------------------------------
; * Copyright (c) 2016 ARM Ltd.
; *
; * This software is provided 'as-is', without any express or implied warranty.
; * In no event will the authors be held liable for any damages arising from
; * the use of this software. Permission is granted to anyone to use this
; * software for any purpose, including commercial applications, and to alter
; * it and redistribute it freely, subject to the following restrictions:
; *
; * 1. The origin of this software must not be misrepresented; you must not
; *    claim that you wrote the original software. If you use this software in
; *    a product, an acknowledgment in the product documentation would be
; *    appreciated but is not required.
; *
; * 2. Altered source versions must be plainly marked as such, and must not be
; *    misrepresented as being the original software.
; *
; * 3. This notice may not be removed or altered from any source distribution.
; *
; *
; * $Date:        29. June 2016
; * $Revision:    V1.00
; *
; * Project:      Flash Access Control configuration for Kinetis KV3x FAC
; * --------------------------------------------------------------------------- */
;
;/* History:
; *  Version 1.00
; *    Initial release
; */

;/* <<< Use Configuration Wizard in Context Menu >>>                          */


;// <e> Flash Execute-Only Access Control
FLASH_FAC       EQU     0

;// <e> XACC 1  (execute-only access configuration)
XACC_1            EQU     0x00
;//   <h> XACCH
;//     <i> only used for devices with Flash  > 128KB
;//     <o0> XACCH0 (bits XA[63..56]) <0-0xFF>
;//     <o1> XACCH1 (bits XA[55..48]) <0-0xFF>
;//     <o2> XACCH2 (bits XA[47..40]) <0-0xFF>
;//     <o3> XACCH3 (bits XA[39..32]) <0-0xFF>
;//   </h>
;//   <h> XACCL
;//     <o4> XACCL0 (bits XA[31..24]) <0-0xFF>
;//     <o5> XACCL1 (bits XA[23..16]) <0-0xFF>
;//     <o6> XACCL2 (bits XA[15.. 8]) <0-0xFF>
;//     <o7> XACCL3 (bits XA[ 7.. 0]) <0-0xFF>
;//   </h>
;// </e>
XACCH0_1          EQU     0xFF
XACCH1_1          EQU     0xFF
XACCH2_1          EQU     0xFF
XACCH3_1          EQU     0xFF
XACCL0_1          EQU     0xFF
XACCL1_1          EQU     0xFF
XACCL2_1          EQU     0xFF
XACCL3_1          EQU     0xFF


;// <e> XACC 2  (execute-only access configuration)
XACC_2            EQU     0x00
;//   <h> XACCH
;//     <i> only used for devices with Flash  > 128KB
;//     <o0> XACCH0 (bits XA[63..56]) <0-0xFF>
;//     <o1> XACCH1 (bits XA[55..48]) <0-0xFF>
;//     <o2> XACCH2 (bits XA[47..40]) <0-0xFF>
;//     <o3> XACCH3 (bits XA[39..32]) <0-0xFF>
;//   </h>
;//   <h> XACCL
;//     <o4> XACCL0 (bits XA[31..24]) <0-0xFF>
;//     <o5> XACCL1 (bits XA[23..16]) <0-0xFF>
;//     <o6> XACCL2 (bits XA[15.. 8]) <0-0xFF>
;//     <o7> XACCL3 (bits XA[ 7.. 0]) <0-0xFF>
;//   </h>
;// </e>
XACCH0_2          EQU     0xFF
XACCH1_2          EQU     0xFF
XACCH2_2          EQU     0xFF
XACCH3_2          EQU     0xFF
XACCL0_2          EQU     0xFF
XACCL1_2          EQU     0xFF
XACCL2_2          EQU     0xFF
XACCL3_2          EQU     0xFF


;// <e> SACC 1  (supervisor-only access configuration)
SACC_1            EQU     0x00
;//   <h> SACCH
;//     <i> only used for devices with Flash  > 128KB
;//     <o0> SACCH0 (bits SA[63..56]) <0-0xFF>
;//     <o1> SACCH1 (bits SA[55..48]) <0-0xFF>
;//     <o2> SACCH2 (bits SA[47..40]) <0-0xFF>
;//     <o3> SACCH3 (bits SA[39..32]) <0-0xFF>
;//   </h>
;//   <h> SACCL
;//     <o4> SACCL0 (bits SA[31..24]) <0-0xFF>
;//     <o5> SACCL1 (bits SA[23..16]) <0-0xFF>
;//     <o6> SACCL2 (bits SA[15.. 8]) <0-0xFF>
;//     <o7> SACCL3 (bits SA[ 7.. 0]) <0-0xFF>
;//   </h>
;// </e>
SACCH0_1          EQU     0xFF
SACCH1_1          EQU     0xFF
SACCH2_1          EQU     0xFF
SACCH3_1          EQU     0xFF
SACCL0_1          EQU     0xFF
SACCL1_1          EQU     0xFF
SACCL2_1          EQU     0xFF
SACCL3_1          EQU     0xFF

;// <e> SACC 2  (supervisor-only access configuration)
SACC_2            EQU     0x00
;//   <h> SACCH
;//     <i> only used for devices with Flash  > 128KB
;//     <o0> SACCH0 (bits SA[63..56]) <0-0xFF>
;//     <o1> SACCH1 (bits SA[55..48]) <0-0xFF>
;//     <o2> SACCH2 (bits SA[47..40]) <0-0xFF>
;//     <o3> SACCH3 (bits SA[39..32]) <0-0xFF>
;//   </h>
;//   <h> SACCL
;//     <o4> SACCL0 (bits SA[31..24]) <0-0xFF>
;//     <o5> SACCL1 (bits SA[23..16]) <0-0xFF>
;//     <o6> SACCL2 (bits SA[15.. 8]) <0-0xFF>
;//     <o7> SACCL3 (bits SA[ 7.. 0]) <0-0xFF>
;//   </h>
;// </e>
SACCH0_2          EQU     0xFF
SACCH1_2          EQU     0xFF
SACCH2_2          EQU     0xFF
SACCH3_2          EQU     0xFF
SACCL0_2          EQU     0xFF
SACCL1_2          EQU     0xFF
SACCL2_2          EQU     0xFF
SACCL3_2          EQU     0xFF

;// </e>


                IF      FLASH_FAC <> 0
                AREA    |.ARM.__AT_0xFFFF0000|, CODE, READONLY   ; we use a virtual address
				DCB     XACC_1, XACC_2, SACC_1, SACC_2
                DCB     XACCH3_1, XACCH2_1, XACCH1_1, XACCH0_1, XACCL3_1, XACCL2_1, XACCL1_1, XACCL0_1
                DCB     XACCH3_2, XACCH2_2, XACCH1_2, XACCH0_2, XACCL3_2, XACCL2_2, XACCL1_2, XACCL0_2
                DCB     SACCH3_1, SACCH2_1, SACCH1_1, SACCH0_1, SACCL3_1, SACCL2_1, SACCL1_1, SACCL0_1
                DCB     SACCH3_2, SACCH2_2, SACCH1_2, SACCH0_2, SACCL3_2, SACCL2_2, SACCL1_2, SACCL0_2
                ENDIF

                END
