#ifndef _MKV3x_DEVICE_H_
#define _MKV3x_DEVICE_H_

#include <stdint.h>

/* one block for each device/algorithm */
/*-----------------------------------------------------------------------*/
#if   defined KV3x

  static __inline void Watchdog_Disable(void) {
    (*((volatile uint16_t *)(0x4005200Eu))) = 0xC520u;                /* WDOG->UNLOCK  = (uint16_t)0xC520u; */
    (*((volatile uint16_t *)(0x4005200Eu))) = 0xD928u;                /* WDOG->UNLOCK  = (uint16_t)0xD928u; */
    (*((volatile uint16_t *)(0x40052000u))) = 0x01D2u;                /* WDOG->STCTRLH = (uint16_t)0x01D2u; */
  }

  static __inline void RunMode_Set(void) {
    __nop();
  }

  /* destination to program security key back to flash location */
//#define SECURITY_LOCATION             0x408               /* because we write 8 Bytes */
  #define SECURITY_LOCATION             0x40C               /* because we write 4 Bytes */
  #define SECURITY_SIZE                 FSL_FEATURE_FLASH_PFLASH_BLOCK_WRITE_UNIT_SIZE

#else
  #error "flash_device not configured."
#endif

#endif /* #if _MKV3x_DEVICE_H_ */
